﻿using Rhino.DocObjects;

namespace Test
{
    public static class RhinoExtensions
    {
        private static readonly string _boolKey = "BoolKey";
        private static readonly string _doubleKey = "DoubleKey";
        public static bool GetTestBool(this RhinoObject rhinoObject)
        {
            var hasBool = rhinoObject.Geometry.UserDictionary.ContainsKey(_boolKey);
            if (hasBool) return (bool)rhinoObject.Geometry.UserDictionary[_boolKey];
            return false; //default
        }

        public static void SetTestBool(this RhinoObject rhinoObject, bool boolValue)
        {
            rhinoObject.Geometry.UserDictionary.Set(_boolKey, boolValue);
        }
        public static double GetTestDecimal(this RhinoObject rhinoObject)
        {
            var hasDecimal = rhinoObject.Geometry.UserDictionary.ContainsKey(_doubleKey);
            if (hasDecimal) return (double)rhinoObject.Geometry.UserDictionary[_doubleKey];
            return 1; //default
        }

        public static void SetTestDecimal(this RhinoObject rhinoObject, double doubleValue)
        {
            rhinoObject.Geometry.UserDictionary.Set(_doubleKey, doubleValue);
        }
    }
}
