﻿using Rhino;
using Rhino.PlugIns;
using Rhino.UI;
using System;
using System.Collections.Generic;
using Test.UI.ObjectSettings;

namespace Test
{
    public class TestPlugIn : PlugIn
    {
        TestObjectProperties object_properties;

        public Dictionary<Guid, double> ObjectAreas = new Dictionary<Guid, double>();


        public TestPlugIn()
        {
            Instance = this;

            object_properties = new TestObjectProperties(Instance);
        }

        public static TestPlugIn Instance
        {
            get; private set;
        }

        public void RecalculateObject(Guid objectId)
        {
            PluginHandler.Instance.SetDirty(objectId);
            RhinoApp.Idle += RhinoApp_Idle;
        }

        public void OnRecalculated()
        {
            object_properties.CalculationsUpdated();
        }

        private void RhinoApp_Idle(object sender, EventArgs e)
        {
            RhinoApp.Idle -= RhinoApp_Idle;
            RhinoApp.RunScript("_-testrecalculate", false);
        }

        public override PlugInLoadTime LoadTime => PlugInLoadTime.AtStartup;

        protected override LoadReturnCode OnLoad(ref string errorMessage)
        {
            PluginHandler.Instance.Enable(true, this);

            return LoadReturnCode.Success;
        }

        protected override void ObjectPropertiesPages(List<ObjectPropertiesPage> pages)
        {
            pages.Add(object_properties);
            base.ObjectPropertiesPages(pages);
        }
    }
}