﻿using Eto.Forms;
using Rhino.UI.Controls;
using System;
using Test.UI.ObjectSettings.Sections;

namespace Test.UI.ObjectSettings
{
    public class ObjectSettingsPanel : Panel
    {
        private TestObjectProperties _objectProperties;

        private EtoCollapsibleSectionHolder holder;
        private Section objectInfoSection;
        private Section groundFloorServiceSection;

        public static Guid PanelId
        {
            get
            {
                return typeof(ObjectSettingsPanel).GUID;
            }
        }

        public ObjectSettingsPanel(TestObjectProperties ojectProperties)
        {
            _objectProperties = ojectProperties;
        }

        public void ResetSections()
        {
            holder = new EtoCollapsibleSectionHolder();
            objectInfoSection = new SimpleObjectInfo(_objectProperties);
            groundFloorServiceSection = new CalculationInputsSection(_objectProperties);

            holder.Add(objectInfoSection);
            holder.Add(groundFloorServiceSection);

            Content = holder;
        }

        public void UpdateSections()
        {
            if (_objectProperties.RhinoObject == null) return;
            objectInfoSection.UpdateSection();
        }
    }
}