﻿using Eto.Forms;
using Rhino.UI;

namespace Test.UI.ObjectSettings.Sections
{
    public class CalculationInputsSection : Section
    {
        TestObjectProperties _objectProperties;
        private LocalizeStringPair m_caption;

        private Label _boolValueLabel;
        private CheckBox _boolValueCheckBox;

        public override LocalizeStringPair Caption
        {
            get { return m_caption; }
        }

        public override int SectionHeight
        {
            get
            {
                return this.Content.Height;
            }
        }

        public CalculationInputsSection(TestObjectProperties objectProperties)
        {
            _objectProperties = objectProperties;
            m_caption = new LocalizeStringPair("Computation", "Computation Inputs");
            InitializeComponents();
            InitializeLayout();
        }


        private void InitializeComponents()
        {
            _boolValueLabel = new Label() { Text= "Bool value" };
            _boolValueCheckBox = new CheckBox();
            _boolValueCheckBox.Checked = _objectProperties.RhinoObject.GetTestBool();
            _boolValueCheckBox.CheckedChanged += _boolValueCheckBox_CheckedChanged;
        }

        private void InitializeLayout()
        {
            var layout = new TableLayout()
            {
                Padding = 10,
                Spacing = new Eto.Drawing.Size(15, 10),
                Rows =
                {
                    new TableRow(_boolValueLabel, _boolValueCheckBox),
                }
            };
            Content = layout;
        }

        private void _boolValueCheckBox_CheckedChanged(object sender, System.EventArgs e)
        {
            _objectProperties.RhinoObject.SetTestBool(((CheckBox)sender).Checked.Value);
            _objectProperties.Plugin.RecalculateObject(_objectProperties.RhinoObject.Id);
        }
    }
}
