﻿using Eto.Forms;
using Rhino.UI;

namespace Test.UI.ObjectSettings.Sections
{
    public class SimpleObjectInfo : Section
    {
        private TestObjectProperties _objectProperties;
        private LocalizeStringPair m_caption;

        private Label _areaLabel;
        private Label _area;

        private TableLayout _tableLayout;

        public override LocalizeStringPair Caption
        {
            get { return m_caption; }
        }

        public override int SectionHeight
        {
            get
            {
                return this.Content.Height;
            }
        }

        public SimpleObjectInfo(TestObjectProperties objectProperties)
        {
            _objectProperties = objectProperties;
            m_caption = new LocalizeStringPair("ObjectInfo", "Object Info");
            InitializeLayout();
            UpdateSection();
        }

        private void InitializeLayout()
        {
            var layout = new TableLayout()
            {
                Padding = 10,
                Spacing = new Eto.Drawing.Size(15, 10),
            };


            _areaLabel = new Label() { Text = "Calculated area" };
            _area = new Label();

            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));
            layout.Rows.Add(new TableRow(new Label() { Text="Row"}, new Label() { Text = "Row" }));

            _tableLayout = new TableLayout()
            {
                Padding = 10,
                Spacing = new Eto.Drawing.Size(15, 10),
            };
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));
            _tableLayout.Rows.Add(new TableRow(new Label() { Text = "Checked Row" }, new Label() { Text = "Row" }));


            layout.Rows.Add(new TableRow(_areaLabel, _area));

            var finalLayout = new StackLayout()
            {
                Orientation = Orientation.Vertical,
            };

            finalLayout.Items.Add(layout);
            finalLayout.Items.Add(_tableLayout);

            Content = finalLayout;
        }


        public override void UpdateSection()
        {
            var data = _objectProperties.Plugin.ObjectAreas[_objectProperties.RhinoObject.Id];
            _area.Text = data.ToString();

            _tableLayout.Visible = _objectProperties.RhinoObject.GetTestBool();
        }
    }
}
